angular.module('starter.utils')

.factory('OportunidadUtils', function(PropiedadUtils) {

  function processOportunidad(value) {
    if (value != null && value != undefined) {
      value['_volatile_code'] = '??';
      if (value['name'] != undefined) {
        var palabras = value.name.trim().split(' ');
        var letra01 = '';
        var letra02 = '';
        for (var j = 0; j < palabras.length; j++) {
          if (palabras[j] != '' && palabras[j].toLowerCase() != 'de') {
            if (letra01 == '') {
              letra01 = palabras[j].toUpperCase()[0];
            } else if (letra02 == '') {
              letra02 = palabras[j].toUpperCase()[0];
            }
            if (letra01 != '' && letra02 != '')
              break;
          }
        }
        value._volatile_code = letra01+letra02;
      }
    }
    return value;    
  }

  function processOportunidades(values) {
    var result = [];
    if (values != undefined && values['objects'] != undefined && values.objects['length'] != undefined && values.objects.length > 0) {
      for (var i = 0; i < values.objects.length; i++) {
        var io = processOportunidad(values.objects[i]);
        console.log(JSON.stringify(io));
        result.push(io);
      }
    }
    return result;
  }

  function extractMetainfo(value) {
    var result = null;
    if (value != null && value != undefined) {
      result = value.meta;
    }
    return result;
  }

  return {
    metadata : extractMetainfo,
    process : processOportunidad,
    processList : processOportunidades
  };
});