angular.module('starter.utils')

.factory('TipoPropiedadUtils', function() {
  
  function processList(listIn) {
    var mapIdIcons = [
      'img/tipoProps/00_unknow.svg',
      'img/tipoProps/01_terreno.svg',
      'img/tipoProps/02_dpto.svg',
      'img/tipoProps/03_casa.svg',
      'img/tipoProps/04_quinta.svg',
      'img/tipoProps/05_oficina.svg',
      'img/tipoProps/06_amarra.svg',
      'img/tipoProps/07_local.svg',
      'img/tipoProps/08_edif-comercial.svg',
      'img/tipoProps/09_campo.svg',
      'img/tipoProps/10_cochera.svg',
      'img/tipoProps/11_hotel.svg',
      'img/tipoProps/12_nave.svg',
      'img/tipoProps/13_ph.svg',
      'img/tipoProps/14_deposito.svg',
      'img/tipoProps/15_fondo-comercio.svg',
      'img/tipoProps/16_baulera.svg',
      'img/tipoProps/17_bodega.svg',
      'img/tipoProps/18_finca.svg',
      'img/tipoProps/19_chacra.svg',
      'img/tipoProps/20_camanautica.svg'
    ];

    if (listIn != null && listIn != undefined && listIn.length > 0) {
      for (var pos=0; pos < listIn.length; pos++) {
        var icono = mapIdIcons[0];
        if (listIn[pos]['id'] != undefined && listIn[pos]['id'] < mapIdIcons.length)
          icono = mapIdIcons[listIn[pos]['id']];
        listIn[pos]['selected'] = false;
        listIn[pos]['img'] = icono;        
      }
    }
    return listIn;
  }

  function processListToInvoke(listIn) {
    var listOut = [];
    if (listIn != null && listIn != undefined && listIn.length > 0) {
      for (var pos=0; pos < listIn.length; pos++) {
        listOut.push(listIn[pos].id);
      }
    }
    return listOut;
  }
  
  return {
    processList: processList,
    processListToInvoke: processListToInvoke
  };
});